#!/usr/bin/perl -w

use strict;

use Getopt::Std;

my $input1;
my $input2;
my $output;

my %option;
my @lines;
my $lno=0;
my $l1="";
my $l2="";


#-c ARG -m ARG

getopts("c:m:", \%option);

if ($option{c}) { 
    $input1= $option{c}; 
    if ($input1 =~ /(\S+)\.+(\S+)$/) {
        $output = $1 . "_merged3." . $2;
    }
    else {
      die "Ebakorrektne failinimi\n";
    }  
}
else {
   $input1="-";
   $output="merged.txt";
}  

if ($option{m}) { 
    $input2= $option{m};
}
else {die "Puudub maltparseri sisend\n";}
 

print "Loetakse cgfailist $input1, maltparseri failist $input2, kirjutatakse $output\n";

    open(INPUT1,"< $input1")
        || die "Cant open $input1 for input: $!\n";
    open(INPUT2,"< $input2") 
        || die "Cant open $input2 for input: $!\n";
    open(OUT,"> $output") 
        || die "Cant open $output for output: $!\n";
        
    select(OUT);

@lines=<INPUT2>;
    
while(<INPUT1>){
  chomp();
  if (/^(.*)\t\d+\t(\S+)\t_\t_\s*$/){
      $l1 = $1;
      $l2 = $2;
      #print "# ", $l, ">\n";
      if ($lines[$lno] =~ /\t(\d+)\t\S+\t_\t_\s*$/){
        $l1 = $l1 . "\t" . $1 . "\t" . $l2 ."\t_\t_";
        print $l1;
        print "\n";
      }
      else {
        print STDERR "Read pole kohakuti $lno\n";
        print "_\t_\t_\n";
      }
  }
  else {
    print;
    print "\n";
  }
  $lno++; 
}

close(INPUT1);
close(INPUT2);
close(OUT);

sub teisenda{
  my $tag = shift;
  my $pos;
  
  my $no;
  my $head;
  
  if ($tag =~ /subj/) {return "\@SUBJ";}
  if ($tag =~ /obj/) {return "\@OBJ";}
  if ($tag =~ /prd/) {return "\@PRD";}
  if ($tag =~ /advl/) {return "\@ADVL";}
  if ($tag =~ /punc/) {return "xxx";}
  if ($tag =~ /conj/) {return "\@J";}
  if ($tag =~ /i/) {return "\@I";}
  if ($tag =~ /b/) {return "\@B";}
  
  #leia sõltuvuse suund
  if ($lines[$lno] =~ /^(\d+)\s*/){
    $no=$1;
  } else {
    $no=0;
  }  
  
  if ($lines[$lno] =~ /^\d+\s*.*\t(\d+)\t/){
    $head=$1;
  } else {
    $head=1;
  } 
    
  if ($tag =~ /adp/) {
     if ($no<$head) {
       return "\@P>";
     } else {
       return "\@<P";
     }
  }
  
  if ($tag =~ /qtr/) {
     if ($no<$head) {
       return "\@Q>";
     } else {
       return "\@<Q";
     }
  }
  
  
  if ($tag =~ /attr/) {
     $pos=sl($lines[$lno]);
     
     if ($no<$head) {
       if ($pos =~ /A/) {return "\@AN>";}
       if ($pos =~ /S/) {return "\@NN>";}
       if ($pos =~ /N/) {return "\@NN>";}
       if ($pos =~ /Y/) {return "\@NN>";}
       if ($pos =~ /P/) {return "\@NN>";}
       if ($pos =~ /D/) {return "\@DN>";}
       if ($pos =~ /K/) {return "\@KN>";}
       if ($pos =~ /V/  && $lines[$lno] =~ /partic/) {return "\@VN>";}
       return "\@INFN>";
     } else {
       if ($pos =~ /A/) {return "\@<AN";}
       if ($pos =~ /S/) {return "\@<NN";}
       if ($pos =~ /N/) {return "\@<NN";}
       if ($pos =~ /P/) {return "\@<NN";}
       if ($pos =~ /D/) {return "\@<DN";}
       if ($pos =~ /K/) {return "\@<KN";}
       if ($pos =~ /V/  && $lines[$lno] =~ /partic/) {return "\@<VN";}
       return "\@<INFN";
     }
  }
  
  if ($tag =~ /vg/) {
     $pos=sl($lines[$lno]);
     if ($pos =~ /D/) {return "\@Vpart";}
     if ($pos =~ /Vaux/ && $lines[$lno] =~ /ps\d+/ ) {return "\@FCV";}
     if ($pos =~ /Vaux/ && $lines[$lno] !~ /ps\d+/ ) {return "\@ICV";}
     if ($pos =~ /Vmod/ && $lines[$lno] =~ /ps\d+/ ) {return "\@FCV";}
     if ($pos =~ /Vmod/ && $lines[$lno] !~ /ps\d+/ ) {return "\@ICV";}
     if ($pos =~ /V/ && $lines[$lno] =~ /ps\d+/ ) {return "\@FMV";}
     if ($pos =~ /V/ && $lines[$lno] !~ /ps\d+/ ) {return "\@IMV";}
  }
   if ($tag =~ /ROOT/) {return "\@FMV";}
   return "xxx";
}  

sub sl{
  my $ll = shift;
  #print STDERR "####", $ll;
     if ($ll=~ /^\S+\s+\S+\s+\S+\s+\S+\s+(\S+)\s+/) {
       #print STDERR "-->", $1, "\n";
       return $1;
     }
     return "M";
}